Subject: Re: [nfsv4] [3530bis] Driving another nail into the UDP coffin

From: RJ Atkinson <[email-masked]>
Date: Wed, 19 Oct 2011 15:04:59 -0400

Earlier, Daniel Ellard wrote:
> I think it would be more effective to focus what characteristics of
> the transport are required, rather than specific examples, although
> examples are fine for clarifications.

The recent list discussion demonstrated that the approach
advocated in the paragraph quoted above is ambiguous, and
leads to confusion, rather than clarity.

> For example: "The requirements are <as stated>.  Examples of protocols
> that satisfy these requirements are TCP, SCTP, and RDMA[1].  UDP is an
> example of a protocol that does not."

Again, list discussion shows that wording above is not adequately clear,
in part because UDP *can* meet those requirements in combination
with DCCP or NORM.

> I might even go further: "Implementations SHOULD support TCP, and MAY
> support additional protocols."

We agree that NFSv4/TCP ought to be supported.  

In my view, NFSv4/TCP is the only approach that has a decent chance 
of interoperating, at least for now.

I would not add that "MAY" clause.  We don't need entropy or
vagueness in the specification of NFSv4 operation over the 
Internet protocol suite -- which is what that "MAY" does.  

In turn, that entropy and confusion likely would harm interoperability 
in the deployed world.  One of the main goals of the IETF, 
and its sometimes cumbersome processes, is to increase interoperability.

> I wouldn't mention NORM or DCCP anywhere; they're red herrings.  

They aren't red herrings of any kind.   In fact, the current
discussion begs the question of where NORM+UDP and DCCP+UDP
fall in a requirements-driven taxonomy for NFSv4 transport.

So NORM and DCCP need to be discussed, one way or another, 
because they are widely available IETF standards-track protocols 
that enable UDP to meet the functional requirements proposed 
in the text quoted up top.  

My suggestion is to clearly say that NFSv4 is not operated
over either UDP+NORM or UDP+DCCP.  No one seems to be advocating
either combination, so it isn't obvious to me why saying 
they aren't used with NFSv4 would be controversial.

Cheers,

Ran